package javax.rtgedition;

/***********************************************
  *  RTG, University of Pennsylvania
  * Author:	Dave Arney	11/07/01
  *                    Woongsup Kim
  **********************************************/

public class PeriodicTimer extends Timer {

RelativeTime intervalTime;
HighResolutionTime startTime;

    public PeriodicTimer( HighResolutionTime start, RelativeTime interval,
AsyncEventHandler handler) {
        this(start,interval,null,handler);
    }

   public PeriodicTimer (HighResolutionTime start, RelativeTime interval, Clock clock, AsyncEventHandler handler) {
        super(start,null,handler);
        startTime = start;
        intervalTime = interval;
    }


    public ReleaseParameters createReleaseparameters()
{
        RelativeTime cost = new RelativeTime(intervalTime);
        ReleaseParameters rp = new PeriodicParameters(startTime,intervalTime,cost,null, null,null);
        return rp;
    }

    public RelativeTime getInterval() {
		return intervalTime;
    }

    public void setInterval (RelativeTime interval)
 {
        intervalTime = interval;
    }

  public void enable () {
	synchronized(this) {
		isEnabled = true;
		if (thread != null) {
			thread.interrupt();
		}
	}
  }

    public void start () {
	enable();
	thread = new RealtimeThread() {
		public void run() {
			for(;;) {
				try {
					RealtimeThread.sleep(PeriodicTimer.this.clock, PeriodicTimer.this.fireTime);
					reschedule(new AbsoluteTime(fireTime.add(intervalTime)));
					synchronized(PeriodicTimer.this) {
						if (isEnabled) {
							PeriodicTimer.this.fire();
						}
					}
				} catch(InterruptedException e) {
				}
			}
		}
	};
	thread.setDaemon(true);
	thread.start();
  }


}
