package javax.rtgedition;

/***********************************************
 *  RTG, University of Pennsylvania
  * Author:	Dave Arney	11/07/01
  *                    Woongsup Kim
  **********************************************/

public class RationalTime extends RelativeTime
{
	public RationalTime(int frequency){
		super();
		this.frequency = frequency;
	}
	
	public RationalTime(int frequency, long millis, int nanos){
		this.frequency = frequency;
		this.millis = millis;
		this.nanos = nanos;
	}
	
	public RationalTime(int frequency, RelativeTime interval){
		super(interval);
		this.frequency = frequency;
	}
	
	public AbsoluteTime absolute(Clock clock, AbsoluteTime destination){
		destination = clock.getTime();
		destination.add(millis, nanos);
		return destination;
	}
	
	public void addIntervalTo(AbsoluteTime destination){
		destination.add(this,destination);
	}
	
	public int getFrequency(){
		return this.frequency;
	}
	
	public RelativeTime getInterarrivalTime(RelativeTime dest){
		long m;
		int n;
		m = this.millis/this.frequency;
		n = this.nanos/this.frequency;
		dest.set(m,n);
		return dest;
	}
	

	public void set(long millis, int nanos){
		super.set(millis, nanos);
	}

	
	public void setFrequency(int frequency) throws IllegalArgumentException{
		if(frequency != 0){
			this.frequency = frequency;
		}
		else {
			throw new IllegalArgumentException();
/*			System.out.println("Wrong Frequency value");
 <sigh> -DA*/
		}
	}
}
